
C-PAC: Configurable Pipeline for the Analysis of Connectomes
============================================================
[![DOI](http://bids.neuroimaging.io/openneuro_badge.svg)](https://openneuro.org) [![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.164638.svg)](https://doi.org/10.5281/zenodo.164638)


A configurable, open-source, Nipype-based, automated processing pipeline for resting state fMRI data. 
Designed for use by both novice users and experts, C-PAC brings the power, flexibility and elegance 
of Nipype to users in a plug-and-play fashion; no programming required.

Website
-------

The C-PAC website is located here:  http://fcp-indi.github.com/

Installation
------------

Installation instructions can be found within the user documentation: http://fcp-indi.github.io/docs/user/install.html

Documentation
-------------

User documentation can be found here: http://fcp-indi.github.com/docs/user/index.html

Developer documentation can be found here: http://fcp-indi.github.com/docs/developer/index.html

Documentation pertaining to this latest release can be found here: https://github.com/FCP-INDI/C-PAC/releases/tag/v1.4.0


Discussion Forum
---------------

If you are stuck and need help or have any other questions or comments about C-PAC, there is a C-PAC discussion forum here: https://groups.google.com/forum/#!forum/cpax_forum

Issue Tracker and Bugs
----------------------

This is a beta version of C-PAC, which means that it is still under active development. As such, although we have done our best to ensure a stable pipeline, there will likely still be a few bugs that we did not catch. If you find a bug or would like to suggest a new feature, please open an issue on the the C-PAC Github issue tracker: https://github.com/FCP-INDI/C-PAC/issues?state=open

If you would like to suggest revisions to the user documentation, please open an issue on the C-PAC website's Github issue tracker: https://github.com/FCP-INDI/fcp-indi.github.com/issues

